<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="88px"
    >
      <el-form-item label="吊钩类型" prop="hookName">
        <el-input
          v-model="queryParams.hookName"
          placeholder="请输入吊钩类型"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
          >重置</el-button
        >
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['app:hook:add']"
          >新增</el-button
        >
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['app:hook:remove']"
          >删除</el-button
        >
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="hookList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="ID" align="center" prop="id" width="80" /> -->
      <el-table-column label="吊钩类型" align="center" prop="hookName" />
      <el-table-column label="吊钩扣重(kg)" align="center" prop="hookWeight" />
      <el-table-column label="默认吊钩" align="center" prop="defaultFlag">
        <template slot-scope="scope">
          <el-tag v-if="scope.row.defaultFlag">是</el-tag>
          <el-tag v-else type="info">否</el-tag>
        </template>
      </el-table-column>
      <el-table-column
        label="操作"
        align="center"
        width="180"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-view"
            @click="handleView(scope.row)"
            >查看</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['app:hook:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['app:hook:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改吊钩对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        :disabled="isView"
        label-width="120px"
      >
        <el-form-item label="吊钩类型" prop="hookName">
          <el-input v-model="form.hookName" placeholder="请输入吊钩类型" />
        </el-form-item>
        <el-form-item label="吊钩扣重(kg)" prop="hookWeight">
          <el-input v-model="form.hookWeight" placeholder="请输入吊钩扣重" />
        </el-form-item>
        <el-form-item label="默认吊钩" prop="defaultFlag">
          <el-switch
            v-model="form.defaultFlag"
            active-text="是"
            inactive-text="否"
          >
          </el-switch>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer" v-if="!isView">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listHook,
  getHook,
  delHook,
  addHook,
  updateHook,
} from "@/api/app/hook";

export default {
  name: "Hook",
  data() {
    var valiHookWeight = (rule, value, callback) => {
      //包含小数的数字
      let reg = /^(0?\.(0[1-9]|[1-9]\d?)|([1-4]?\d|50)(\.\d{1,2})?)$/;
      if (value === "") {
        callback(new Error("吊钩扣重不能为空"));
      } else if (
        !reg.test(value) ||
        parseFloat(value) < 0.01 ||
        parseFloat(value) > 50.0
      ) {
        callback(
          new Error("吊钩扣重输入超出设定范围限制（0.01~50.00）,保留两位小数")
        );
      } else {
        callback();
      }
    };
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 吊钩表格数据
      hookList: [],
      // 弹出层标题
      title: "",
      isView: false,
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        hookName: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        hookName: [
          { required: true, message: "吊钩类型不能为空", trigger: "blur" },
          {
            min: 1,
            max: 10,
            message: "吊钩类型输入超出最大长度限制（10位）",
            trigger: "blur",
          },
        ],
        hookWeight: [
          { required: true, message: "吊钩扣重不能为空", trigger: "blur" },
          { validator: valiHookWeight, trigger: "blur" },
        ],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    // changeHookWeight(val){
    //   this.$set(this.form,"hookWeight",parseFloat(val).toFixed(2));
    //   console.log(this.form.hookWeight)
    // },
    /** 查询吊钩列表 */
    getList() {
      this.loading = true;
      listHook(this.queryParams).then((response) => {
        this.hookList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        hookName: null,
        hookWeight: null,
        defaultFlag:false,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.isView = false;
      this.title = "添加吊钩";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getHook(id).then((response) => {
        this.form = response.data;
        this.form.hookWeight = this.form.hookWeight
          ? parseFloat(this.form.hookWeight).toFixed(2)
          : 0;
        this.open = true;
        this.isView = false;
        this.title = "修改吊钩";
      });
    },
    /** 查看按钮操作 */
    handleView(row) {
      this.reset();
      const id = row.id || this.ids;
      getHook(id).then((response) => {
        this.form = response.data;
        this.form.hookWeight = this.form.hookWeight
          ? parseFloat(this.form.hookWeight).toFixed(2)
          : 0;
        this.open = true;
        this.isView = true;
        this.title = "查看吊钩";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.form.hookWeight = this.form.hookWeight
        ? parseFloat(this.form.hookWeight).toFixed(2)
        : 0;
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateHook(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addHook(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal
        .confirm('是否确认删除吊钩ID为"' + ids + '"的数据项？')
        .then(function () {
          return delHook(ids);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "app/hook/export",
        {
          ...this.queryParams,
        },
        `hook_${new Date().getTime()}.xlsx`
      );
    },
  },
};
</script>
